/*****************************************************************************
    TRAVIS - Trajectory Analyzer and Visualizer
    http://www.travis-analyzer.de/

    Copyright (c) 2009-2017 Martin Brehm
                  2012-2017 Martin Thomas

    This file written by Martin Brehm.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*****************************************************************************/


// This must always be the first include directive
#include "config.h"

#include "xdmatrixmn.h"
#include "tools.h"


void CxDMatrixMN::Dump() const
{
	BXIN;
	int z, z2;
	for (z=0;z<m_iRows;z++)
	{
		for (z2=0;z2<m_iCols;z2++)
			if (fabs(GetAt(z,z2)) < 0.000005)
				mprintf(" %11.5f",0.0);
			else
				mprintf(" %11.5f",GetAt(z,z2));
		mprintf("\n");
	}
	BXOUT;
}


void CxDMatrixMN::Dump(FILE *a) const
{
	BXIN;
	int z, z2;
	for (z=0;z<m_iRows;z++)
	{
		for (z2=0;z2<m_iCols;z2++)
			if (fabs(GetAt(z,z2)) < 0.000005)
				mfprintf(a," %11.5f",0.0);
			else
				mfprintf(a," %11.5f",GetAt(z,z2));
		mfprintf(a,"\n");
	}
	BXOUT;
}


void CxDMatrixMN::DumpSmall() const
{
	BXIN;
	int z, z2;
	for (z=0;z<m_iRows;z++)
	{
		for (z2=0;z2<m_iCols;z2++)
			if (fabs(GetAt(z,z2)) < 0.00000005)
				mprintf(" %10.7f",0.0);
			else
				mprintf(" %10.7f",GetAt(z,z2));
		mprintf("\n");
	}
	BXOUT;
}


void CxDMatrixMN::DumpSmall(FILE *a) const
{
	BXIN;
	int z, z2;
	for (z=0;z<m_iRows;z++)
	{
		for (z2=0;z2<m_iCols;z2++)
			if (fabs(GetAt(z,z2)) < 0.00000005)
				mfprintf(a," %10.7f",0.0);
			else
				mfprintf(a," %10.7f",GetAt(z,z2));
		mfprintf(a,"\n");
	}
	BXOUT;
}


